/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     zccrs <zccrs@live.com>
 *
 * Maintainer: zccrs <zhangjide@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "widget.h"
#include <QApplication>
#include <QTimer>
#include <QProcess>
#include <QDebug>
#include <QThread>

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    Widget w;
    w.show();

    // do minimize
    QTimer::singleShot(1000, [&] {
        qDebug() << "begin show minimize";
        w.showMinimized();
        qDebug() << w.windowState();
        QProcess::execute(QString("xprop -id %1 WM_STATE _NET_WM_STATE").arg(w.winId()));
        qDebug() << "end show minimize";
        qDebug() << endl << endl << endl;
    });

    QTimer::singleShot(2000, [&] {
        qDebug() << "begin active window";
        w.activateWindow();
        QThread::msleep(500);
        QProcess::execute(QString("xprop -id %1 WM_STATE _NET_WM_STATE").arg(w.winId()));
        qDebug() << "end active window";
        qDebug() << endl << endl << endl;
    });

    QTimer::singleShot(4000, [&] {
        qDebug() << w.windowState();
        a.quit();
    });

    return a.exec();
}
